import { LRLanguage, LanguageSupport } from "@codemirror/language";
import { Extension } from "@codemirror/state";
/**
 * Represents a variable or a property of an object
 */
interface ELIdentifier {
    name: string;
    detail?: string;
    info?: string;
    type?: string[];
}
/**
 * Represents a function or a method of an object
 */
interface ELFunction {
    name: string;
    args: ELParameter[];
    info?: string;
    returnType?: string[];
}
interface ELParameter {
    name: string;
    type?: string[];
    info?: string;
    optional?: boolean;
}
interface ELType {
    identifiers?: ELIdentifier[];
    functions?: ELFunction[];
    info?: string;
}
interface ExpressionLanguageConfig {
    types?: {
        [key: string]: ELType;
    };
    identifiers?: ELIdentifier[];
    functions?: ELFunction[];
}
declare const ELLanguage: LRLanguage;
declare function expressionlanguage(config?: ExpressionLanguageConfig, extensions?: Extension[]): LanguageSupport;
export { ELFunction, ELIdentifier, ExpressionLanguageConfig, ELLanguage, expressionlanguage };
